package libreria;

import java.util.*;
import java.io.*;

public class Libreria
{
	Map<String, Libro> titoli;//titolo->libro
	Map<String, List<Libro>> autori;//autore->lista di libri
	Scanner stdin;

	public Libreria()
	{
		titoli = new HashMap<String, Libro>();
		autori = new TreeMap<String, List<Libro>>();
		stdin = new Scanner(System.in);
	}

	public static void main(String[] argv)
	{
		//(new Libreria()).exec(argv);
		(new Libreria()).exec();
	}

	//void exec(String[] argv)
	void exec()
	{
		while(true)
		{
			System.out.print("Titolo/Autore/Leggi/Stampa/Esci ? >");
			String cmd = stdin.nextLine();
			if(cmd.equals("Esci"))
			{
				break;
			}
			else if(cmd.equals("Stampa"))
			{
				System.out.println(autori);
			}
			else if(cmd.equals("Leggi"))
			{
				Scanner fs = null;
				while(fs == null)
				{
					System.out.print("Nome file ? > ");
					String nome = stdin.nextLine();
					try
					{
						fs = new Scanner(new File(nome));
					}
					catch(FileNotFoundException fnfe)
					{
						fnfe.printStackTrace();
					}
				}

				Libro l = null;
				Set<String> daOrdinare = new HashSet<String>();
				while(fs.hasNextLine())
				{
					l = new Libro();
					if(! l.popola(fs))
					{
						break;
					}

					//se non devo sostituire le istanze anche se uguali
					/*
					if(titoli.containsKey(l.getTitolo()))
					{
						continue;
					}
					*/

					//se sostituire con uno nuovo uguale va bene
					if(titoli.put(l.getTitolo(), l) != null)
					{
						continue;
					}

					List<Libro> lista = autori.get(l.getAutore());
					if(lista == null)
					{
						lista = new LinkedList<Libro>();
						autori.put(l.getAutore(), lista);
					}
					lista.add(l);
					//Aggiungo alla lista daOrdinare
					daOrdinare.add(l.getAutore());
					System.out.println(daOrdinare);
					//Collections.sort(lista);
				}
				Iterator<String> iter = daOrdinare.iterator();
				while(iter.hasNext())
				{
					System.out.println("Ordino");
					Collections.sort(autori.get(iter.next()));
				}
				fs.close();
			}
			else if(cmd.equals("Autore"))
			{
				System.out.print("Autore? > ");
				String aut = stdin.nextLine();
				List<Libro> l = autori.get(aut);
				System.out.println(l);
			}
			else if(cmd.equals("Titolo"))
			{
				System.out.print("Titolo? > ");
				String tit = stdin.nextLine();
				Libro l = titoli.get(tit);
				System.out.println(l);
			}
			else
			{
				System.out.println("Comando <" + cmd + " non riconosciuto");
			}
		}
	}
}
