package scaffali;

import java.util.*;
import java.io.*;

public class Libreria
{
	Scaffale scaf;

	static final String nomeFileStato = "libreria.txt";

	public Libreria(Scanner sc) throws InstantiationException
	{
		int numRip = 0;
		int larghezzaRip = 0;

		numRip = Integer.parseInt(sc.nextLine());
		larghezzaRip = Integer.parseInt(sc.nextLine());
		scaf = new Scaffale(numRip, larghezzaRip);
		//e poi leggo il file di dati
		//...
		while(sc.hasNextLine())
		{
			String titolo = sc.nextLine();
			int spessore = Integer.parseInt(sc.nextLine());

			Pubblicazione p = new Pubblicazione(spessore, titolo);
			CoordinatePubblicazione cp = scaf.inserisciPubblicazione(p);
			if(cp == null)
			{
				throw new InstantiationException("Una pubblicazione precedentemente presente non puo' piu' essere inserita");
			}

			System.out.println("Pubblicazione <" + p + "> inserita in posizione: " + cp);
		}
	}

	public Libreria(int numRip, int larghezzaRip)
	{
		scaf = new Scaffale(numRip, larghezzaRip);
	}

	public String toString()
	{
		return "Libreria con scaffale: " + scaf.toString();
	}

	public static void main(String[] argv) throws FileNotFoundException, InstantiationException
	{
		File f = new File(nomeFileStato);
		Libreria l = null;
		if(f.canRead())
		{
			Scanner sc = new Scanner(f);
			l = new Libreria(sc);
		}
		else
		{
			try
			{
				l = new Libreria(Integer.parseInt(argv[0]), Integer.parseInt(argv[1]));
			}
			catch(NumberFormatException nfe)
			{
				System.err.println("Usage: Libreria <numero ripiani> <larghezza ripiani>");
				System.exit(1);
			}
			catch(ArrayIndexOutOfBoundsException aioobe)
			{
				System.err.println("Usage: Libreria <numero ripiani> <larghezza ripiani>");
				System.exit(1);
			}
		}

		System.out.println(l);

		Scanner stdin = new Scanner(System.in);
		try
		{
			while(true)
			{
				System.out.print("Leggi Pubblicazione/Cerca/Rimuovi/Leggi File/Stampa/Esci ? >");
				System.out.flush();
				String line = stdin.nextLine();
	
				if(line.equalsIgnoreCase("leggi pubblicazione"))
				{
					System.out.print("titolo ? > ");
					String titolo = stdin.nextLine();
					System.out.print("spessore ? > ");
					int spessore = Integer.parseInt(stdin.nextLine());
					Pubblicazione p = new Pubblicazione(spessore, titolo);
					CoordinatePubblicazione cp = l.scaf.inserisciPubblicazione(p);
					if(cp != null)
					{
						System.out.println("Pubblicazione <" + p + "> inserita in " + cp);
					}
					else
					{
						System.out.println("Scaffale pieno");
					}
				}
				else if(line.equalsIgnoreCase("Cerca"))
				{
				}
				else if(line.equalsIgnoreCase("Rimuovi"))
				{
					System.out.print("titolo ? > ");
					String titolo = stdin.nextLine();
					CoordinatePubblicazione cp = l.scaf.rimuoviPubblicazione(titolo);
					if(cp == null)
					{
						System.out.println("Pubblicazione < " + titolo + "> non presente");
					}
					else
					{
						System.out.println("Pubblicazione < " + titolo + "> rimossa da posizione " + cp);
					}
				}
				else if(line.equalsIgnoreCase("Leggi File"))
				{
				}
				else if(line.equalsIgnoreCase("Stampa"))
				{
					System.out.println(l.scaf);
				}
				else if(line.equalsIgnoreCase("Esci"))
				{
					break;
				}
			}
		}
		catch(NoSuchElementException nsee)
		{
		}
		finally
		{
			System.out.println("Salvataggio stato");
			//
			PrintWriter pw = new PrintWriter(f);
			l.scaf.serializzati(pw);
			pw.flush();
			pw.close();
		}
	}
}
